﻿' 
'    Copyright (c) 2011 Microsoft Corporation.  All rights reserved.
'    Use of this sample source code is subject to the terms of the Microsoft license 
'    agreement under which you licensed this sample source code and is provided AS-IS.
'    If you did not accept the terms of the license agreement, you are not authorized 
'    to use this sample source code.  For the terms of the license, please see the 
'    license agreement between you and Microsoft.
'  
'    To see the MSDN article about this app, visit http://go.microsoft.com/fwlink/?LinkId=247592 
'  
'
Imports System.Collections.ObjectModel
Imports FeedCastLibrary

Namespace Models
    Public Class FeedsInGroup
        Inherits ObservableCollection(Of Feed)
        Implements IComparable(Of FeedsInGroup)

        Public Sub New(ByVal category As String)
            Key = category
        End Sub

        Public Property Key As String

        Public ReadOnly Property HasItems As Boolean
            Get
                Return Count > 0
            End Get
        End Property

        ''' <summary>
        ''' Compares this instance with the specified FeedsInGroup and indicates
        ''' whether this instance precedes, follows, or appears in the 
        ''' same position in the sort order as the specified FeedsInGroup.
        ''' </summary>
        ''' <param name="other"></param>
        ''' <returns>Less than zero if this instance precedes "other".
        ''' Zero if this instance has the same position in the sort order as "other".
        ''' Greater than 0 if This instance follows value or value is null.</returns>
        Public Function CompareTo(ByVal other As FeedsInGroup) As Integer Implements IComparable(Of FeedsInGroup).CompareTo
            Return Me.Key.Chars(0).CompareTo(other.Key.Chars(0))
        End Function
    End Class
End Namespace