﻿' 
'    Copyright (c) 2011 Microsoft Corporation.  All rights reserved.
'    Use of this sample source code is subject to the terms of the Microsoft license 
'    agreement under which you licensed this sample source code and is provided AS-IS.
'    If you did not accept the terms of the license agreement, you are not authorized 
'    to use this sample source code.  For the terms of the license, please see the 
'    license agreement between you and Microsoft.
'  
'    To see the MSDN article about this app, visit http://go.microsoft.com/fwlink/?LinkId=247592 
'  
'
Imports System.Collections.ObjectModel
Imports FeedCast.Models
Imports FeedCastLibrary

Namespace ViewModels
    Public Class MainPageAllFeedsViewModel
        Inherits ObservableCollection(Of FeedsInGroup)

        ''' <summary>
        ''' All the groups for the long list selector.
        ''' </summary>
        Private Shared ReadOnly Groups As String = "#abcdefghijklmnopqrstuvwxyz"

        ''' <summary>
        ''' A dictionary of group letter to feeds in such group.
        ''' </summary>
        Private _groupings As Dictionary(Of String, FeedsInGroup)

        Public Sub New()
            _groupings = New Dictionary(Of String, FeedsInGroup)

            For Each c In Groups
                Dim group As New FeedsInGroup(c.ToString)
                Me.Add(group)
                _groupings(c.ToString) = group
            Next c

            Dim feeds As List(Of Feed) = App.DataBaseUtility.GetAllFeeds
            For Each f In feeds
                AddFeed(f)
            Next f
        End Sub

        Public Sub AddFeed(ByVal feed As Feed)
            _groupings(feed.GetNameKey).Add(feed)
        End Sub

        Public Sub RemoveFeed(ByVal feed As Feed)
            _groupings(feed.GetNameKey).Remove(feed)
        End Sub

        Public Function ContainsFeed(ByVal feed As Feed) As Boolean
            Return _groupings(feed.GetNameKey).Contains(feed)
        End Function
    End Class
End Namespace