﻿' 
'    Copyright (c) 2011 Microsoft Corporation.  All rights reserved.
'    Use of this sample source code is subject to the terms of the Microsoft license 
'    agreement under which you licensed this sample source code and is provided AS-IS.
'    If you did not accept the terms of the license agreement, you are not authorized 
'    to use this sample source code.  For the terms of the license, please see the 
'    license agreement between you and Microsoft.
'  
'    To see the MSDN article about this app, visit http://go.microsoft.com/fwlink/?LinkId=247592 
'  
'
Imports FeedCast.Models
Imports FeedCastLibrary

Namespace ViewModels
    Public Class MainPageFeaturedViewModel
        Inherits DependencyObject

#Region "HubTile Article Properties"
        Public Property HubTileArticle1 As Article
            Get
                Return CType(GetValue(HubTileArticle1Property), Article)
            End Get
            Set(ByVal value As Article)
                SetValue(HubTileArticle1Property, value)
            End Set
        End Property

        Public Shared ReadOnly HubTileArticle1Property As DependencyProperty = DependencyProperty.Register("HubTileArticle1", GetType(Article), GetType(MainPageFeaturedViewModel), New PropertyMetadata(Nothing))

        Public Property HubTileArticle2 As Article
            Get
                Return CType(GetValue(HubTileArticle2Property), Article)
            End Get
            Set(ByVal value As Article)
                SetValue(HubTileArticle2Property, value)
            End Set
        End Property

        Public Shared ReadOnly HubTileArticle2Property As DependencyProperty = DependencyProperty.Register("HubTileArticle2", GetType(Article), GetType(MainPageFeaturedViewModel), New PropertyMetadata(Nothing))

        Public Property HubTileArticle3 As Article
            Get
                Return CType(GetValue(HubTileArticle3Property), Article)
            End Get
            Set(ByVal value As Article)
                SetValue(HubTileArticle3Property, value)
            End Set
        End Property

        Public Shared ReadOnly HubTileArticle3Property As DependencyProperty = DependencyProperty.Register("HubTileArticle3", GetType(Article), GetType(MainPageFeaturedViewModel), New PropertyMetadata(Nothing))

        Public Property HubTileArticle4 As Article
            Get
                Return CType(GetValue(HubTileArticle4Property), Article)
            End Get
            Set(ByVal value As Article)
                SetValue(HubTileArticle4Property, value)
            End Set
        End Property

        Public Shared ReadOnly HubTileArticle4Property As DependencyProperty = DependencyProperty.Register("HubTileArticle4", GetType(Article), GetType(MainPageFeaturedViewModel), New PropertyMetadata(Nothing))

        Public Property HubTileArticle5 As Article
            Get
                Return CType(GetValue(HubTileArticle5Property), Article)
            End Get
            Set(ByVal value As Article)
                SetValue(HubTileArticle5Property, value)
            End Set
        End Property

        Public Shared ReadOnly HubTileArticle5Property As DependencyProperty = DependencyProperty.Register("HubTileArticle5", GetType(Article), GetType(MainPageFeaturedViewModel), New PropertyMetadata(Nothing))

        Public Property HubTileArticle6 As Article
            Get
                Return CType(GetValue(HubTileArticle6Property), Article)
            End Get
            Set(ByVal value As Article)
                SetValue(HubTileArticle6Property, value)
            End Set
        End Property

        Public Shared ReadOnly HubTileArticle6Property As DependencyProperty = DependencyProperty.Register("HubTileArticle6", GetType(Article), GetType(MainPageFeaturedViewModel), New PropertyMetadata(Nothing))
#End Region

        ''' <summary>
        ''' Constructor
        ''' </summary>
        Public Sub New()
            GetFeatured()
        End Sub

        ''' <summary>
        ''' Obtains the latest featured articles and sets them up to be displayed.
        ''' </summary>
        Public Sub GetFeatured()
            ' Gather the latest featured articles.
            ' If there are no new ones, then old ones will be used.
            FeaturedAlgorithm.UpdateFeatured()

            ' Set the articles to be displayed.
            ' Gather each article from the database to ensure that it actually exists.
            If Settings.FeaturedArticles IsNot Nothing Then
                HubTileArticle1 = App.DataBaseUtility.QueryArticle(Convert.ToInt32(Settings.FeaturedArticles(0).ArticleID))
                HubTileArticle2 = App.DataBaseUtility.QueryArticle(Convert.ToInt32(Settings.FeaturedArticles(1).ArticleID))
                HubTileArticle3 = App.DataBaseUtility.QueryArticle(Convert.ToInt32(Settings.FeaturedArticles(2).ArticleID))
                HubTileArticle4 = App.DataBaseUtility.QueryArticle(Convert.ToInt32(Settings.FeaturedArticles(3).ArticleID))
                HubTileArticle5 = App.DataBaseUtility.QueryArticle(Convert.ToInt32(Settings.FeaturedArticles(4).ArticleID))
                HubTileArticle6 = App.DataBaseUtility.QueryArticle(Convert.ToInt32(Settings.FeaturedArticles(5).ArticleID))
            End If
        End Sub

        ''' <summary>
        ''' Updates the Featured section if an article inside was removed.
        ''' </summary>
        Public Sub RedoFeatured()
            Dim articlesExist As Boolean = True

            ' Check to see if all the featured articles still exist.
            For Each article In Settings.FeaturedArticles
                If Nothing Is App.DataBaseUtility.QueryArticle(Convert.ToInt32(article.ArticleID)) Then
                    articlesExist = False
                    Exit For
                End If
            Next article

            ' If they don't, get new ones.
            If Not articlesExist Then
                GetFeatured()
            End If
        End Sub
    End Class
End Namespace