﻿' 
'    Copyright (c) 2011 Microsoft Corporation.  All rights reserved.
'    Use of this sample source code is subject to the terms of the Microsoft license 
'    agreement under which you licensed this sample source code and is provided AS-IS.
'    If you did not accept the terms of the license agreement, you are not authorized 
'    to use this sample source code.  For the terms of the license, please see the 
'    license agreement between you and Microsoft.
'  
'    To see the MSDN article about this app, visit http://go.microsoft.com/fwlink/?LinkId=247592 
'  
'

Imports Microsoft.Phone.Tasks

Namespace ViewModels
    Public NotInheritable Class ShareUtility
        ' The body for each message.
        Private Shared ReadOnly _messageTitle As String = "Cool article"
        Private Shared ReadOnly _messageBody As String = "Hey, check out this article: "

        Private Sub New()
        End Sub

        Public Shared Sub ShareLink(ByVal link As String)
            Dim shareLinkTask As New ShareLinkTask
            shareLinkTask.Title = _messageTitle
            shareLinkTask.Message = _messageBody & link
            shareLinkTask.LinkUri = New Uri(link, UriKind.Absolute)
            shareLinkTask.Show()
        End Sub

        Public Shared Sub ShareSMS(ByVal link As String)
            Dim smsComposeTask As New SmsComposeTask
            smsComposeTask.Body = _messageBody & link
            smsComposeTask.Show()
        End Sub

        Public Shared Sub ShareEmail(ByVal link As String)
            Dim emailComposeTask As New EmailComposeTask
            emailComposeTask.Subject = _messageTitle
            emailComposeTask.Body = _messageBody & link
            emailComposeTask.Show()
        End Sub

        Public Shared Sub LaunchBrowser(ByVal link As String)
            Dim webBrowserTask As New WebBrowserTask
            webBrowserTask.Uri = New Uri(link, UriKind.Absolute)
            webBrowserTask.Show()
        End Sub
    End Class
End Namespace