﻿' 
'    Copyright (c) 2011 Microsoft Corporation.  All rights reserved.
'    Use of this sample source code is subject to the terms of the Microsoft license 
'    agreement under which you licensed this sample source code and is provided AS-IS.
'    If you did not accept the terms of the license agreement, you are not authorized 
'    to use this sample source code.  For the terms of the license, please see the 
'    license agreement between you and Microsoft.
'  
'    To see the MSDN article about this app, visit http://go.microsoft.com/fwlink/?LinkId=247592 
'  
'

Imports System.Windows.Navigation

Namespace Views
    ''' <summary>
    ''' Intermediate page where the user decides if they want to add a new feed or category.
    ''' </summary>
    Partial Public Class AddMenu
        Inherits PhoneApplicationPage

        Public Sub New()
            InitializeComponent()
        End Sub

        Protected Overrides Sub OnNavigatedFrom(ByVal e As NavigationEventArgs)
            MyBase.OnNavigatedFrom(e)

            If e.NavigationMode = NavigationMode.New Then
                NavigationService.RemoveBackEntry()
            End If
        End Sub

        ''' <summary>
        ''' Navigate to the NewFeed page, where the user can add new feeds.
        ''' </summary>
        Private Sub OnNewFeedTap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)
            NavigationService.Navigate(New Uri("/NewFeed", UriKind.Relative))
        End Sub

        ''' <summary>
        ''' Navigate to the NewCategory page, where the user can add new categories.
        ''' </summary>
        Private Sub OnNewCategoryTap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)
            NavigationService.Navigate(New Uri("/NewCategory", UriKind.Relative))
        End Sub
    End Class
End Namespace