﻿' 
'    Copyright (c) 2011 Microsoft Corporation.  All rights reserved.
'    Use of this sample source code is subject to the terms of the Microsoft license 
'    agreement under which you licensed this sample source code and is provided AS-IS.
'    If you did not accept the terms of the license agreement, you are not authorized 
'    to use this sample source code.  For the terms of the license, please see the 
'    license agreement between you and Microsoft.
'  
'    To see the MSDN article about this app, visit http://go.microsoft.com/fwlink/?LinkId=247592 
'  
'
Partial Public Class Category
    Implements IComparable(Of Category), IEquatable(Of Category)

    ''' <summary>
    ''' Compares this instance with the specified category and indicates
    ''' whether this instance precedes, follows, or appears in the 
    ''' same position in the sort order as the specified category.
    ''' </summary>
    ''' <param name="other"></param>
    ''' <returns>Less than zero if this instance precedes "other".
    ''' Zero if this instance has the same position in the sort order as "other".
    ''' Greater than 0 if This instance follows value or value is null.</returns>
    Public Function CompareTo(ByVal other As Category) As Integer Implements IComparable(Of Category).CompareTo
        Return Me.CategoryTitle.CompareTo(other.CategoryTitle)
    End Function

    ''' <summary>
    ''' Determines whether two category objects have the same value.
    ''' </summary>
    ''' <param name="other">The category to compare this category to.</param>
    ''' <returns>True if this category has the same value as "other" category,
    ''' otherwise false.</returns>
    Public Overloads Function Equals(ByVal other As Category) As Boolean Implements IEquatable(Of Category).Equals
        Return Me.CategoryTitle.Equals(other.CategoryTitle)
    End Function

    ''' <summary>
    ''' Returns a string that represents this category.
    ''' </summary>
    ''' <returns>A string representation of this category.</returns>
    Public Overrides Function ToString() As String
        Return Me.CategoryTitle
    End Function
End Class
