﻿' 
'    Copyright (c) 2011 Microsoft Corporation.  All rights reserved.
'    Use of this sample source code is subject to the terms of the Microsoft license 
'    agreement under which you licensed this sample source code and is provided AS-IS.
'    If you did not accept the terms of the license agreement, you are not authorized 
'    to use this sample source code.  For the terms of the license, please see the 
'    license agreement between you and Microsoft.
'  
'    To see the MSDN article about this app, visit http://go.microsoft.com/fwlink/?LinkId=247592 
'  
'
Imports System.Collections.ObjectModel

Public Class SearchResultParser
    Implements IXmlFeedParser

    ''' <summary>
    ''' Object to moderate thread access to collection adding.
    ''' </summary>
    Private Shared ReadOnly _lockObject As New Object

    ''' <summary>
    ''' Default constructor
    ''' </summary>
    Public Sub New()
    End Sub

    ''' <summary>
    ''' Parse the results of the Bing search
    ''' </summary>
    ''' <param name="reader">The xml reader containing the search results</param>
    Public Function ParseItems(ByVal reader As XmlReader, ByVal ownerFeed As Feed) As Collection(Of Article)
        Dim results As New Collection(Of Article)
        reader.ReadToFollowing("item")
        Do
            If reader.ReadToFollowing("title") Then
                Dim name As String = reader.ReadElementContentAsString

                If reader.ReadToFollowing("link") Then
                    Dim uri As String = reader.ReadElementContentAsString

                    ' Assign feed information to Article object.
                    Dim newResult As Article = New Article With {.ArticleTitle = name, .ArticleBaseURI = uri}
                    ' Safely add the search result to the collection.
                    SyncLock _lockObject
                        results.Add(newResult)
                    End SyncLock
                End If
            End If
        Loop While reader.ReadToFollowing("item")
        Return results
    End Function

    Public Function ParseItems1(reader As System.Xml.XmlReader, ownerFeed As Feed) As System.Collections.ObjectModel.Collection(Of Article) Implements IXmlFeedParser.ParseItems
        Return Nothing
    End Function
End Class